import sys
import time

import pandas as pd
from spilt import spilt
from train import train
from construct import construct
from test import predict
import os
os.environ['TF_CPP_MIN_LOG_LEVEL']='3'


command_para = sys.argv[1:]

data_path = command_para[0]
label_path = command_para[1]
spilt_num = command_para[2]
feature_selection_type = command_para[3]
classification_type = command_para[4]
name = command_para[5]
'''
data_path = "D:/HILAB/thesis1/cfluo/asd/data.csv"
label_path = "D:/HILAB/thesis1/cfluo/asd/label.csv"
spilt_num = "0.333333" note:0.333333 is the set of extended experiment,
    the parameter is defaulted in 0.5 comparition experiment
feature_selection_type = "RF"
classification_type = "NBayes"
'''


path1 = './result'
if os.path.exists(path1) == False:
    os.mkdir(path1)

path2 = './result/sample'
if os.path.exists(path2) == False:
    os.mkdir(path2)

path3 = './result/model'
if os.path.exists(path3) == False:
    os.mkdir(path3)

start0 = time.perf_counter()
# spilt
data = pd.read_csv('./'+name+'/'+name+'.500.'+data_path, index_col=0)
label = pd.read_csv('./'+name+'/'+name+'.500.'+label_path, index_col=0)   
spilt(data, label)#input data，include data和label
end0 = time.perf_counter()

start1 = time.perf_counter()
# train
train_data1 = pd.read_csv("./result/sample/data_train1.csv", index_col=0)
train_label1 = pd.read_csv("./result/sample/label_train1.csv", index_col=0)
#Training based on the train and label obtained by spilt
train(feature_selection_type, train_data1, train_label1)


train_data = pd.read_csv("./result/sample/data_train.csv", index_col=0)
train_label = pd.read_csv("./result/sample/label_train.csv", index_col=0)
test_data = pd.read_csv("./result/sample/data_test.csv", index_col=0)
test_label = pd.read_csv("./result/sample/label_test.csv", index_col=0)
end1 = time.perf_counter()


start2 = time.perf_counter()
# EvaGoNet_encoded features
construct(feature_selection_type ,train_data ,train_label ,test_data ,test_label)#Construction based on the results obtained from training
# predict(feature selection)
end2 = time.perf_counter()
print("spilt:"+str(end0-start0))
print("train:"+str(end1-start1))
print("construct:"+str(end2-start2))
start3 = time.perf_counter()
predict(feature_selection_type, classification_type, test_data, test_label ,train_data,train_label)#prediction
end3 = time.perf_counter()
print("predict:"+str(end3-start3))
