import sys
import pandas as pd
from spilt import spilt
from train import train
from construct import construct
from test import predict
import os
os.environ["CUDA_VISIBLE_DEVICES"] = "-1"


command_para = sys.argv[1:]

data_path = command_para[0]
label_path = command_para[1]
spilt_num = command_para[2]
feature_selection_type = command_para[3]
classification_type = command_para[4]
name = command_para[5]
'''
data_path = "D:/HILAB/thesis1/cfluo/data.csv"
label_path = "D:/HILAB/thesis1/cfluo/label.csv"
spilt_num = "0.2"
feature_selection_type = "Ttest"
classification_type = "DTree"
'''


path1 = './result'
if os.path.exists(path1) == False:
    os.mkdir(path1)

path2 = './result/sample'
if os.path.exists(path2) == False:
    os.mkdir(path2)

path3 = './result/model'
if os.path.exists(path3) == False:
    os.mkdir(path3)

# spilt
data = pd.read_csv('./'+name+'/'+name+'.500.'+data_path, index_col=0)
label = pd.read_csv('./'+name+'/'+name+'.500.'+label_path, index_col=0)
#data = pd.read_csv("D:/HILAB/thesis1/cfluo/data.csv", index_col=0)    
#label = pd.read_csv("D:/HILAB/thesis1/cfluo/label.csv", index_col=0)    
spilt(data, label, spilt_num)

# train
train_data = pd.read_csv("./result/sample/data_train.csv", index_col=0)
train_label = pd.read_csv("./result/sample/label_train.csv", index_col=0)
train(feature_selection_type, train_data, train_label)

test_data = pd.read_csv("./result/sample/data_test.csv", index_col=0)
test_label = pd.read_csv("./result/sample/label_test.csv", index_col=0)
# BioSAE_encoded features
construct(feature_selection_type, test_data ,test_label)
# predict(feature selection)
predict(feature_selection_type, classification_type, test_data, test_label)
