import sys
import numpy as np
import pandas as pd
from scipy import stats
from sklearn.impute import KNNImputer
#from fancyimpute import KNN
import os

command_para = sys.argv[1:]

data_path = command_para[0]
feature_num = command_para[1]
data_name = command_para[2]

path1 = './data'
if os.path.exists(path1) == False:
    os.mkdir(path1)

path2 = path1 + '/' + data_name
if os.path.exists(path2) == False:
    os.mkdir(path2)
path3 = path2 + '/'
path4 = './'+data_name+'/'
tTag = data_name + "." + feature_num

data = pd.read_csv(data_path, index_col=0, compression='gzip')
data = data.drop(['Gene_Symbol', 'Chromosome', 'Genomic_Coordinate'], axis=1)
n = int(0.9 * data.shape[1])
data = data.dropna(thresh=n)

o_label = data.columns.values.tolist()
B = []
for i in o_label:
    B.append(i[0:12])
data.columns = B

#select data
pic_label = pd.read_csv(path4+"label.csv", index_col=0)
pic_label1 = pic_label['sample'].tolist()
label_class = pic_label['class'].tolist()
intersection = list(set(pic_label1) & set(B))
data = data[intersection]
label = pd.DataFrame(np.array([pic_label1, label_class]), columns=pic_label1)
label = label[intersection]
label = pd.DataFrame(np.array(label).T)
label.columns=['sample','class']

#label.to_csv(path3 + "label.csv", index=False)
label.to_csv(path3 + tTag+"." + "label.csv", index=False)
imputer = KNNImputer(n_neighbors=3)
arr = imputer.fit_transform(data)
#arr = KNN(k=3).fit_transform(data)
data1 = arr.T


def Ttest(X, Y, ttest_num):
    Y1 = np.where(Y == 1)[0]
    Y0 = np.where(Y == 0)[0]
    p_list = []
    for i in range(len(X[0])):
        p_l = stats.levene(X[Y1, i], X[Y0, i])[1]
        equal_var = [True if p_l > 0.05 else False]
        p_list.append(stats.ttest_ind(X[Y1, i], X[Y0, i], equal_var=equal_var)[1])
    T_index = np.argsort(np.array(p_list))[0:ttest_num]
    X1 = X[:, T_index]
    return T_index

D = []
C = label['class'].tolist()
for i in C:
    D.append(1 if i == '1' else 0)
Y = np.array(D)
index = Ttest(data1, Y, int(feature_num))
data2 = data1[:, index]
data2 = pd.DataFrame(data2, index=intersection)
#data2.to_csv(path3 + "data.csv")
data2.to_csv(path3 + tTag+"." + "data.csv")

