import sys
import numpy as np
import pandas as pd
from scipy import stats
from sklearn import preprocessing
from sklearn.impute import KNNImputer
#from fancyimpute import KNN
import os

command_para = sys.argv[1:]

data_path = command_para[0]
feature_num = command_para[1]
data_name = command_para[2]

path1 = './data'
if os.path.exists(path1) == False:
    os.mkdir(path1)

path2 = path1 + '/' + data_name
if os.path.exists(path2) == False:
    os.mkdir(path2)
path3 = path2 + '/'
path4 = './'+data_name+'/'
tTag = data_name + "." + feature_num
fea_id_path = "./MethylationFeature-cgID.index_data.csv"

data = pd.read_csv(data_path, index_col=0)
data.index = range(len(data))
fea_id = pd.read_csv(fea_id_path, index_col=0)
fea_id = np.array(fea_id.index)

#normal process
min_max_scaler = preprocessing.MinMaxScaler()
min_max_scaler1 = preprocessing.MinMaxScaler(feature_range = (0,1),copy = 1)

for i in data.index:
    for j in range(0, data.shape[1]):
        if data.loc[i].values[j] == 0:
            data.loc[i].values[j] = np.nan

n = int(0.9 * data.shape[1])
data = data.dropna(thresh=n)
fea_label = np.array(data.index)

o_label = data.columns.values.tolist()
B = []
for i in o_label:
    B.append(i[0:12])

#select data
pic_label = pd.read_csv(path4+ "label.csv", index_col=0)
pic_label1 = pic_label['sample'].tolist()
label_class = pic_label['class'].tolist()
intersection = list(set(pic_label1) & set(B))

o_intersection = []
for j in intersection:
    for i in o_label:
        if i[0:12] == j:
            o_intersection.append(i)
            break
label = pd.DataFrame(np.array([pic_label1, label_class]), columns=pic_label1)
label = label[intersection]
label = pd.DataFrame(np.array(label).T)
label[0] = o_intersection
label.columns = ['sample', 'class']

print("sample numble:")
print(len(o_intersection))
data = data[o_intersection]

print("data size：")
print(data.shape)

#label.to_csv(path3 + "label.csv", index=False)
label.to_csv(path3 + tTag+"." + "label.csv", index=False)
imputer = KNNImputer(n_neighbors=3)
arr = imputer.fit_transform(data)
#arr = KNN(k=3).fit_transform(data)
data1 = arr.T

data1 = min_max_scaler.fit_transform(data1)

def Ttest(X, Y, ttest_num):
    Y1 = np.where(Y == 1)[0]
    Y0 = np.where(Y == 0)[0]
    p_list = []
    for i in range(len(X[0])):
        p_l = stats.levene(X[Y1, i], X[Y0, i])[1]
        equal_var = [True if p_l > 0.05 else False]
        p_list.append(stats.ttest_ind(X[Y1, i], X[Y0, i], equal_var=equal_var)[1])
    T_index = np.argsort(np.array(p_list))[0:ttest_num]
    X1 = X[:, T_index]
    return T_index

D = []
C = label['class'].tolist()
for i in C:
    D.append(1 if i == '1' else 0)
Y = np.array(D)
index = Ttest(data1, Y, int(feature_num))
data2 = data1[:, index]
fea_label = fea_id[np.array(fea_label[index])].tolist()
data2 = pd.DataFrame(data2, index=o_intersection,columns=fea_label)
#data2.to_csv(path3 + "data.csv")
data2.to_csv(path3 + tTag+"." + "data.csv")